org.eclipse.wst.jsdt.core.dom

## Interface IVariableBinding

All Superinterfaces:
  IBinding

    public interface IVariableBinding
    extends IBinding

A variable binding represents either a field of a class or interface, or a local variable declaration (including formal parameters, local variables, and exception variables).

This interface is not intended to be implemented by clients.

See Also:
  `Provisional API: This class/interface is part of an interim API that is still under development and expected to change significantly before reaching stability. It is being made available at this early stage to solicit feedback from pioneering adopters on the understanding that any code that uses this API will almost certainly be broken (repeatedly) as the API evolves.`

### Field Summary

### Fields inherited from interface org.eclipse.wst.jsdt.core.dom.IBinding

`METHOD, PACKAGE, TYPE, VARIABLE`

### Method Summary

All Methods Instance Methods Abstract Methods
`java.lang.Object` `getConstantValue()` Returns this binding's constant value if it has one.
`ITypeBinding` `getDeclaringClass()` Returns the type binding representing the class or interface that declares this field.
`IFunctionBinding` `getDeclaringMethod()` Returns the method binding representing the method containing the scope in which this local variable is declared.
`java.lang.String` `getName()` Returns the name of the field or local variable declared in this binding.
`ITypeBinding` `getType()` Returns the binding for the type of this field or local variable.
`IVariableBinding` `getVariableDeclaration()` Returns the binding for the variable declaration corresponding to this variable binding.
`int` `getVariableId()` Returns a small integer variable id for this variable binding.
`boolean` `isField()` Returns whether this binding is for a field.
`boolean` `isGlobal()`
`boolean` `isParameter()` Returns whether this binding corresponds to a parameter.

### Methods inherited from interface org.eclipse.wst.jsdt.core.dom.IBinding

`equals, getJavaElement, getKey, getKind, getModifiers, isDeprecated, isEqualTo, isRecovered, toString`

### Method Detail

#### isField

    boolean isField()

Returns whether this binding is for a field. Note that this method returns `true` for constants, including enum constants. This method returns `false` for local variables.

Returns:
  `true` if this is the binding for a field, and `false` otherwise

#### isGlobal

    boolean isGlobal()

#### isParameter

    boolean isParameter()

Returns whether this binding corresponds to a parameter.

Returns:
  `true` if this is the binding for a parameter, and `false` otherwise

#### getName

    java.lang.String getName()

Returns the name of the field or local variable declared in this binding. The name is always a simple identifier.

Specified by:
  `getName` in interface `IBinding`
Returns:
  the name of this field or local variable

#### getDeclaringClass

    ITypeBinding getDeclaringClass()

Returns the type binding representing the class or interface that declares this field.

The declaring class of a field is the class or interface of which it is a member. Local variables have no declaring class. The field length of an array type has no declaring class.

Returns:
  the binding of the class or interface that declares this field, or `null` if none

#### getType

    ITypeBinding getType()

Returns the binding for the type of this field or local variable.

Returns:
  the binding for the type of this field or local variable

#### getVariableId

    int getVariableId()

Returns a small integer variable id for this variable binding.

Local variables inside methods: Local variables (and parameters) declared within a single method are assigned ascending ids in normal code reading order; var1.getVariableId()<var2.getVariableId() means that var1 is declared before var2.

Local variables outside methods: Local variables declared in a type's static initializers (or initializer expressions of static fields) are assigned ascending ids in normal code reading order. Local variables declared in a type's instance initializers (or initializer expressions of non-static fields) are assigned ascending ids in normal code reading order. These ids are useful when checking definite assignment for static initializers (JLS 16.7) and instance initializers (JLS 16.8), respectively.

Fields: Fields declared as members of a type are assigned ascending ids in normal code reading order; field1.getVariableId()<field2.getVariableId() means that field1 is declared before field2.

Returns:
  a small non-negative variable id

#### getConstantValue

    java.lang.Object getConstantValue()

Returns this binding's constant value if it has one. Some variables may have a value computed at compile-time. If the type of the value is a primitive type, the result is the boxed equivalent (i.e., int returned as an `Integer`). If the type of the value is `String`, the result is the string itself. If the variable has no compile-time computed value, the result is `null`. (Note: compile-time constant expressions cannot denote `null`; JLS2 15.28.). The result is always `null` for enum constants.

Returns:
  the constant value, or `null` if none

#### getDeclaringMethod

    IFunctionBinding getDeclaringMethod()

Returns the method binding representing the method containing the scope in which this local variable is declared.

The declaring method of a method formal parameter is the method itself. For a local variable declared somewhere within the body of a method, the declaring method is the enclosing method. When local or anonymous classes are involved, the declaring method is the innermost such method. There is no declaring method for a field, or for a local variable declared in a static or instance initializer; this method returns `null` in those cases.

Returns:
  the binding of the method or constructor that declares this local variable, or `null` if none

#### getVariableDeclaration

    IVariableBinding getVariableDeclaration()

Returns the binding for the variable declaration corresponding to this variable binding. For a binding for a field declaration in an instance of a generic type, this method returns the binding for the corresponding field declaration in the generic type. For other variable bindings, including all ones for local variables and parameters, this method returns the same binding.

Returns:
  the variable binding for the originating declaration